/* $LAAS: viamcv.h 2009/04/29 14:23:24 mallet $ */

/* 
 * Copyright (c) 2008-2009 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 *
 *					Anthony Mallet on Sat Dec 20 2008
 */

#ifndef H_VIAMCV
#define H_VIAMCV

#include "viam/viamtypes.h"

#ifdef VIAM_OPENCV_SUPPORT

#ifdef __cplusplus
extern "C" {
#endif

#include <cv.h>

/* --- Images -------------------------------------------------------------- */

int		viam_oneshot(viam_handle_t vh, viam_bank_t bank,
			IplImage *image[], struct timeval *timestamps[],
			int nimages);


/* --- Calibration --------------------------------------------------------- */

int		viam_calibration_start(viam_handle_t vh, viam_bank_t bank,
			viam_caltype_t type, int rows, int cols, double size);
int		viam_calibration_addimage(viam_handle_t vh, viam_bank_t bank,
			IplImage *image[], int nimages, double overlapth,
			double motionth, viam_onoff_t feedback, int *result);
int		viam_calibration_estimate(viam_handle_t vh, viam_bank_t bank,
			viam_distortionmodel_t dmodel, double *result);
int		viam_calibration_finish(viam_handle_t vh, viam_bank_t bank);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* VIAM_OPENCV_SUPPORT */

#endif /* H_VIAMCV */
